---
title: "View Refresh"
framework: javascript
version: "36.1.0"
---

# View Refresh

The grid has change detection. So as long as you are updating the data via the grid's API, the values displayed should be the most recent up to date values.

However sometimes you may be updating the data outside of the grid's control. When you give data to the grid, the grid will not make a copy. Thus if you change the value of the data outside of the grid, the grid will not be impacted by that data change.

To deal with the scenario where the row data is changed without the grid being aware, the grid provides the following methods:

- **Refresh Cells**: `api.refreshCells(cellRefreshParams)` - Gets the grid to refresh all cells. Change detection will be used to refresh only cells whose display cell values are out of sync with the actual value. If using a [cellRenderer](https://www.ag-grid.com/javascript-data-grid/component-cell-renderer/) with a refresh method, the refresh method will get called.
- **Redraw Rows**: `api.redrawRows(redrawRowsParams)` - Removes the rows from the DOM and draws them again from scratch. The cells are created again from scratch. No change detection is done. No refreshing of cells is done.

Your preference should be to use `refreshCells()` over `redrawRows()`. Only use `redrawRows()` if you find `refreshCells()` doesn't suit your needs.

## Refresh Cells

To get the grid to refresh the cells, call `api.refreshCells()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  | Performs change detection on all cells, refreshing cells where required. Module: [`RenderApiModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

Each parameter is optional. The simplest is to call with no parameters which will refresh all cells using [change detection](https://www.ag-grid.com/javascript-data-grid/change-detection/) (change detection means it will only refresh cells whose values have changed).

### Example Refresh Cells

Below shows calling `api.refreshCells()` with different scenarios using a mixture of the `rowNodes`, `columns` and `force` parameters. From the example, the following can be noted:

- The defaultColDef has `enableCellChangeFlash=true`, so cells that are refreshed will be flashed.
- Column A has `enableCellChangeFlash=false` which means this column is excluded from the flashing.
- The grid has two pinned rows at the top and two pinned rows at the bottom. This is to demonstrate that cell refreshing works for pinned rows also.
- The three buttons each make use of a **scramble** operation. The scramble operation selects 50% of the cells at random and assigns new values to them. This is done outside of the grid so the grid has not been informed of the data changes. Each button then gets the grid to refresh in a different way.
- The **Scramble & Refresh All** button will scramble the data, then call `api.refreshCells()`. You will notice that randomly half the cells will flash as the change detection only update the cells who's underlying values have changed.
- The **Scramble & Refresh Left to Right** button will scramble as before, then call `api.refreshCells({columns})` 5 times, 100ms apart, once for each column. This will show the grid refreshing one column at a time from left to right.
- The **Scramble & Refresh Top to Bottom** button will scramble as before, then call `api.refreshCells({rowNodes})` 20 times, 100ms apart, once for each row (including pinned rows). This will show the grid refreshing one row at a time from top to bottom.
- The checkbox **Force Refresh** impacts how the above three refreshes work. If checked, all the cells will get refreshed regardless of whether they have changes. In other words, change detection will not be used as part of the refresh.
- The checkbox **Suppress Flash** impacts how the above three refreshes work. If checked, flashing will not occur on any cell.

#### Refresh Cells

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  PinnedRowModule,
  RefreshCellsParams,
  RenderApiModule,
  RowApiModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RenderApiModule,
  RowApiModule,
  HighlightChangesModule,
  PinnedRowModule,
  ClientSideRowModelModule,
]);

// placing in 13 rows, so there are exactly enough rows to fill the grid, makes
// the row animation look nice when you see all the rows
let data: any[] = [];
let topRowData: any[] = [];
let bottomRowData: any[] = [];
let gridApi: GridApi;
const gridOptions: GridOptions = {
  columnDefs: [
    { field: "a", enableCellChangeFlash: false },
    { field: "b" },
    { field: "c" },
    { field: "d" },
    { field: "e" },
    { field: "f" },
  ],
  defaultColDef: {
    flex: 1,
    enableCellChangeFlash: true,
  },
  rowData: [],
  pinnedTopRowData: [],
  pinnedBottomRowData: [],
  onGridReady: (params) => {
    // placing in 13 rows, so there are exactly enough rows to fill the grid, makes
    // the row animation look nice when you see all the rows
    data = createData(14);
    topRowData = createData(2);
    bottomRowData = createData(2);
    params.api.setGridOption("rowData", data);
    params.api.setGridOption("pinnedTopRowData", topRowData);
    params.api.setGridOption("pinnedBottomRowData", bottomRowData);
  },
};

function createData(count: number): any[] {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}

function isForceRefreshSelected() {
  return (document.querySelector("#forceRefresh") as HTMLInputElement).checked;
}

function isSuppressFlashSelected() {
  return (document.querySelector("#suppressFlash") as HTMLInputElement).checked;
}

function scrambleAndRefreshAll() {
  scramble();
  const params = {
    force: isForceRefreshSelected(),
    suppressFlash: isSuppressFlashSelected(),
  };
  gridApi!.refreshCells(params);
}

function scrambleAndRefreshLeftToRight() {
  scramble();

  ["a", "b", "c", "d", "e", "f"].forEach((col, index) => {
    const millis = index * 100;
    const params = {
      force: isForceRefreshSelected(),
      suppressFlash: isSuppressFlashSelected(),
      columns: [col],
    };
    callRefreshAfterMillis(params, millis, gridApi);
  });
}

function scrambleAndRefreshTopToBottom() {
  scramble();

  let frame = 0;
  let i;
  let rowNode;

  for (i = 0; i < gridApi.getPinnedTopRowCount(); i++) {
    rowNode = gridApi.getPinnedTopRow(i)!;
    refreshRow(rowNode, gridApi);
  }

  for (i = 0; i < gridApi.getDisplayedRowCount(); i++) {
    rowNode = gridApi.getDisplayedRowAtIndex(i)!;
    refreshRow(rowNode, gridApi);
  }

  for (i = 0; i < gridApi.getPinnedBottomRowCount(); i++) {
    rowNode = gridApi.getPinnedBottomRow(i)!;
    refreshRow(rowNode, gridApi);
  }

  function refreshRow(rowNode: IRowNode, api: GridApi) {
    const millis = frame++ * 100;
    const rowNodes = [rowNode]; // params needs an array
    const params: RefreshCellsParams = {
      force: isForceRefreshSelected(),
      suppressFlash: isSuppressFlashSelected(),
      rowNodes: rowNodes,
    };
    callRefreshAfterMillis(params, millis, api);
  }
}

function callRefreshAfterMillis(
  params: RefreshCellsParams,
  millis: number,
  api: GridApi,
) {
  setTimeout(() => {
    api.refreshCells(params);
  }, millis);
}

function scramble() {
  data.forEach(scrambleItem);
  topRowData.forEach(scrambleItem);
  bottomRowData.forEach(scrambleItem);
}

function scrambleItem(item: any) {
  ["a", "b", "c", "d", "e", "f"].forEach((colId) => {
    // skip 50% of the cells so updates are random
    if (window.agRandom() > 0.5) {
      return;
    }
    item[colId] = Math.floor(window.agRandom() * 100);
  });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).scrambleAndRefreshAll = scrambleAndRefreshAll;
  (<any>window).scrambleAndRefreshLeftToRight = scrambleAndRefreshLeftToRight;
  (<any>window).scrambleAndRefreshTopToBottom = scrambleAndRefreshTopToBottom;
}
```

[Live example: Refresh Cells](https://www.ag-grid.com/examples/view-refresh/refresh-cells/typescript)

> **Note**
>
> You may be wondering why would you want to force refresh, what is the point in refreshing a cell that has no changes? The answer is to do with cells that don't show underlying data or depend on something other than just the underlying data. One example is a cell that might contain action buttons (add, delete, send etc) and you might want to disable the action buttons if the logged in user changes role (if roles are tied to the functions), or if it's past 5pm and you don't want to allow such operations past a certain time. In this case you may wish to update the cells even though the underlying data has not changed.

## Redraw Rows

Redraw rows is a much heavier operation than refreshing cells. If refreshing cells meets your needs, then don't use redraw rows. A row redraw will rip the row out of the DOM and draw it again from scratch.

Use redraw row if you want to create the row again from scratch. This is useful when you have changed property that only gets used when the row is created for the first time such as:

- Whether the row is [fullWidth](https://www.ag-grid.com/javascript-data-grid/full-width-rows/) or not.
- The cellRenderer used for any cell (as this is specified once when the cell is created).
- You want to specify different styles for the row via the callbacks `getRowStyle()` or `getRowClass()`.

To get the grid to redraw rows, call `api.redrawRows()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `redrawRows` | `Function` |  |  | Remove row(s) from the DOM and recreate them again from scratch. Module: [`RowApiModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

### Example Redraw Nodes

Below shows calling `api.redrawRows()` with different to change the background color of the rows. From the example, the following can be noted:

- The **Redraw All Rows** redraws all the rows using a different background color by calling `api.redrawRows()` with no parameters.
- The **Redraw Top Rows** redraws only the top half of the rows by calling `api.redrawRows({rowNodes})`.

#### Redraw Rows

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowApiModule,
  RowClassParams,
  RowStyle,
  RowStyleModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowApiModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

let colorIndex = 0;
const colors = ["#99999944", "#cc333344", "#33cc3344", "#2244cc44"];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { headerName: "A", field: "a" },
    { headerName: "B", field: "b" },
    { headerName: "C", field: "c" },
    { headerName: "D", field: "d" },
    { headerName: "E", field: "e" },
    { headerName: "F", field: "f" },
  ],
  defaultColDef: {
    flex: 1,
  },
  rowData: createData(12),
  getRowStyle: (params: RowClassParams): RowStyle | undefined => {
    return {
      backgroundColor: colors[colorIndex],
    };
  },
};

function createData(count: number) {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}

function progressColor() {
  colorIndex++;
  if (colorIndex === colors.length) {
    colorIndex = 0;
  }
}

function redrawAllRows() {
  progressColor();
  gridApi!.redrawRows();
}

function redrawTopRows() {
  progressColor();
  const rows = [];
  for (let i = 0; i < 6; i++) {
    const row = gridApi!.getDisplayedRowAtIndex(i)!;
    rows.push(row);
  }
  gridApi!.redrawRows({ rowNodes: rows });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).redrawAllRows = redrawAllRows;
  (<any>window).redrawTopRows = redrawTopRows;
}
```

[Live example: Redraw Rows](https://www.ag-grid.com/examples/view-refresh/redraw-rows/typescript)


---
title: "View Refresh"
framework: angular
version: "36.1.0"
---

# View Refresh

The grid has change detection. So as long as you are updating the data via the grid's API, the values displayed should be the most recent up to date values.

However sometimes you may be updating the data outside of the grid's control. When you give data to the grid, the grid will not make a copy. Thus if you change the value of the data outside of the grid, the grid will not be impacted by that data change.

To deal with the scenario where the row data is changed without the grid being aware, the grid provides the following methods:

- **Refresh Cells**: `api.refreshCells(cellRefreshParams)` - Gets the grid to refresh all cells. Change detection will be used to refresh only cells whose display cell values are out of sync with the actual value. If using a [cellRenderer](https://www.ag-grid.com/angular-data-grid/component-cell-renderer/) with a refresh method, the refresh method will get called.
- **Redraw Rows**: `api.redrawRows(redrawRowsParams)` - Removes the rows from the DOM and draws them again from scratch. The cells are created again from scratch. No change detection is done. No refreshing of cells is done.

Your preference should be to use `refreshCells()` over `redrawRows()`. Only use `redrawRows()` if you find `refreshCells()` doesn't suit your needs.

## Refresh Cells

To get the grid to refresh the cells, call `api.refreshCells()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  | Performs change detection on all cells, refreshing cells where required. Module: [`RenderApiModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

Each parameter is optional. The simplest is to call with no parameters which will refresh all cells using [change detection](https://www.ag-grid.com/angular-data-grid/change-detection/) (change detection means it will only refresh cells whose values have changed).

### Example Refresh Cells

Below shows calling `api.refreshCells()` with different scenarios using a mixture of the `rowNodes`, `columns` and `force` parameters. From the example, the following can be noted:

- The defaultColDef has `enableCellChangeFlash=true`, so cells that are refreshed will be flashed.
- Column A has `enableCellChangeFlash=false` which means this column is excluded from the flashing.
- The grid has two pinned rows at the top and two pinned rows at the bottom. This is to demonstrate that cell refreshing works for pinned rows also.
- The three buttons each make use of a **scramble** operation. The scramble operation selects 50% of the cells at random and assigns new values to them. This is done outside of the grid so the grid has not been informed of the data changes. Each button then gets the grid to refresh in a different way.
- The **Scramble & Refresh All** button will scramble the data, then call `api.refreshCells()`. You will notice that randomly half the cells will flash as the change detection only update the cells who's underlying values have changed.
- The **Scramble & Refresh Left to Right** button will scramble as before, then call `api.refreshCells({columns})` 5 times, 100ms apart, once for each column. This will show the grid refreshing one column at a time from left to right.
- The **Scramble & Refresh Top to Bottom** button will scramble as before, then call `api.refreshCells({rowNodes})` 20 times, 100ms apart, once for each row (including pinned rows). This will show the grid refreshing one row at a time from top to bottom.
- The checkbox **Force Refresh** impacts how the above three refreshes work. If checked, all the cells will get refreshed regardless of whether they have changes. In other words, change detection will not be used as part of the refresh.
- The checkbox **Suppress Flash** impacts how the above three refreshes work. If checked, flashing will not occur on any cell.

#### Refresh Cells

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  PinnedRowModule,
  RefreshCellsParams,
  RenderApiModule,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RenderApiModule,
  RowApiModule,
  HighlightChangesModule,
  PinnedRowModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div>
        <button (click)="scrambleAndRefreshAll()">
          Scramble &amp; Refresh All
        </button>
        <button (click)="scrambleAndRefreshLeftToRight()">
          Scramble &amp; Refresh Left to Right
        </button>
        <button (click)="scrambleAndRefreshTopToBottom()">
          Scramble &amp; Refresh Top to Bottom
        </button>
      </div>
      <div>
        <label>
          <input type="checkbox" id="forceRefresh" />
          Force Refresh
        </label>
        <label>
          <input type="checkbox" id="suppressFlash" />
          Suppress Flash
        </label>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      [pinnedTopRowData]="pinnedTopRowData"
      [pinnedBottomRowData]="pinnedBottomRowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "a", enableCellChangeFlash: false },
    { field: "b" },
    { field: "c" },
    { field: "d" },
    { field: "e" },
    { field: "f" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    enableCellChangeFlash: true,
  };
  rowData: any[] | null = [];
  pinnedTopRowData: any[] = [];
  pinnedBottomRowData: any[] = [];

  scrambleAndRefreshAll() {
    scramble();
    const params = {
      force: isForceRefreshSelected(),
      suppressFlash: isSuppressFlashSelected(),
    };
    this.gridApi.refreshCells(params);
  }

  scrambleAndRefreshLeftToRight() {
    scramble();
    ["a", "b", "c", "d", "e", "f"].forEach((col, index) => {
      const millis = index * 100;
      const params = {
        force: isForceRefreshSelected(),
        suppressFlash: isSuppressFlashSelected(),
        columns: [col],
      };
      callRefreshAfterMillis(params, millis, this.gridApi);
    });
  }

  scrambleAndRefreshTopToBottom() {
    scramble();
    let frame = 0;
    let i;
    let rowNode;
    for (i = 0; i < this.gridApi.getPinnedTopRowCount(); i++) {
      rowNode = this.gridApi.getPinnedTopRow(i)!;
      refreshRow(rowNode, this.gridApi);
    }
    for (i = 0; i < this.gridApi.getDisplayedRowCount(); i++) {
      rowNode = this.gridApi.getDisplayedRowAtIndex(i)!;
      refreshRow(rowNode, this.gridApi);
    }
    for (i = 0; i < this.gridApi.getPinnedBottomRowCount(); i++) {
      rowNode = this.gridApi.getPinnedBottomRow(i)!;
      refreshRow(rowNode, this.gridApi);
    }
    function refreshRow(rowNode: IRowNode, api: GridApi) {
      const millis = frame++ * 100;
      const rowNodes = [rowNode]; // params needs an array
      const params: RefreshCellsParams = {
        force: isForceRefreshSelected(),
        suppressFlash: isSuppressFlashSelected(),
        rowNodes: rowNodes,
      };
      callRefreshAfterMillis(params, millis, api);
    }
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    // placing in 13 rows, so there are exactly enough rows to fill the grid, makes
    // the row animation look nice when you see all the rows
    data = createData(14);
    topRowData = createData(2);
    bottomRowData = createData(2);
    params.api.setGridOption("rowData", data);
    params.api.setGridOption("pinnedTopRowData", topRowData);
    params.api.setGridOption("pinnedBottomRowData", bottomRowData);
  }
}

// placing in 13 rows, so there are exactly enough rows to fill the grid, makes
// the row animation look nice when you see all the rows
let data: any[] = [];
let topRowData: any[] = [];
let bottomRowData: any[] = [];
function createData(count: number): any[] {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}
function isForceRefreshSelected() {
  return (document.querySelector("#forceRefresh") as HTMLInputElement).checked;
}
function isSuppressFlashSelected() {
  return (document.querySelector("#suppressFlash") as HTMLInputElement).checked;
}
function callRefreshAfterMillis(
  params: RefreshCellsParams,
  millis: number,
  api: GridApi,
) {
  setTimeout(() => {
    api.refreshCells(params);
  }, millis);
}
function scramble() {
  data.forEach(scrambleItem);
  topRowData.forEach(scrambleItem);
  bottomRowData.forEach(scrambleItem);
}
function scrambleItem(item: any) {
  ["a", "b", "c", "d", "e", "f"].forEach((colId) => {
    // skip 50% of the cells so updates are random
    if (window.agRandom() > 0.5) {
      return;
    }
    item[colId] = Math.floor(window.agRandom() * 100);
  });
}
```

[Live example: Refresh Cells](https://www.ag-grid.com/examples/view-refresh/refresh-cells/angular)

> **Note**
>
> You may be wondering why would you want to force refresh, what is the point in refreshing a cell that has no changes? The answer is to do with cells that don't show underlying data or depend on something other than just the underlying data. One example is a cell that might contain action buttons (add, delete, send etc) and you might want to disable the action buttons if the logged in user changes role (if roles are tied to the functions), or if it's past 5pm and you don't want to allow such operations past a certain time. In this case you may wish to update the cells even though the underlying data has not changed.

## Redraw Rows

Redraw rows is a much heavier operation than refreshing cells. If refreshing cells meets your needs, then don't use redraw rows. A row redraw will rip the row out of the DOM and draw it again from scratch.

Use redraw row if you want to create the row again from scratch. This is useful when you have changed property that only gets used when the row is created for the first time such as:

- Whether the row is [fullWidth](https://www.ag-grid.com/angular-data-grid/full-width-rows/) or not.
- The cellRenderer used for any cell (as this is specified once when the cell is created).
- You want to specify different styles for the row via the callbacks `getRowStyle()` or `getRowClass()`.

To get the grid to redraw rows, call `api.redrawRows()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `redrawRows` | `Function` |  |  | Remove row(s) from the DOM and recreate them again from scratch. Module: [`RowApiModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

### Example Redraw Nodes

Below shows calling `api.redrawRows()` with different to change the background color of the rows. From the example, the following can be noted:

- The **Redraw All Rows** redraws all the rows using a different background color by calling `api.redrawRows()` with no parameters.
- The **Redraw Top Rows** redraws only the top half of the rows by calling `api.redrawRows({rowNodes})`.

#### Redraw Rows

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowStyle,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  RowClassParams,
  RowStyle,
  RowStyleModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowApiModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <button (click)="redrawAllRows()">Redraw All Rows</button>
      <button (click)="redrawTopRows()">Redraw Top Rows</button>
    </div>

    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      [getRowStyle]="getRowStyle"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { headerName: "A", field: "a" },
    { headerName: "B", field: "b" },
    { headerName: "C", field: "c" },
    { headerName: "D", field: "d" },
    { headerName: "E", field: "e" },
    { headerName: "F", field: "f" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  rowData: any[] | null = createData(12);
  getRowStyle: GetRowStyle = (params: RowClassParams): RowStyle | undefined => {
    return {
      backgroundColor: colors[colorIndex],
    };
  };

  redrawAllRows() {
    progressColor();
    this.gridApi.redrawRows();
  }

  redrawTopRows() {
    progressColor();
    const rows = [];
    for (let i = 0; i < 6; i++) {
      const row = this.gridApi.getDisplayedRowAtIndex(i)!;
      rows.push(row);
    }
    this.gridApi.redrawRows({ rowNodes: rows });
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

let colorIndex = 0;
const colors = ["#99999944", "#cc333344", "#33cc3344", "#2244cc44"];
function createData(count: number) {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}
function progressColor() {
  colorIndex++;
  if (colorIndex === colors.length) {
    colorIndex = 0;
  }
}
```

[Live example: Redraw Rows](https://www.ag-grid.com/examples/view-refresh/redraw-rows/angular)


---
title: "View Refresh"
framework: vue
version: "36.1.0"
---

# View Refresh

The grid has change detection. So as long as you are updating the data via the grid's API, the values displayed should be the most recent up to date values.

However sometimes you may be updating the data outside of the grid's control. When you give data to the grid, the grid will not make a copy. Thus if you change the value of the data outside of the grid, the grid will not be impacted by that data change.

To deal with the scenario where the row data is changed without the grid being aware, the grid provides the following methods:

- **Refresh Cells**: `api.refreshCells(cellRefreshParams)` - Gets the grid to refresh all cells. Change detection will be used to refresh only cells whose display cell values are out of sync with the actual value. If using a [cellRenderer](https://www.ag-grid.com/vue-data-grid/component-cell-renderer/) with a refresh method, the refresh method will get called.
- **Redraw Rows**: `api.redrawRows(redrawRowsParams)` - Removes the rows from the DOM and draws them again from scratch. The cells are created again from scratch. No change detection is done. No refreshing of cells is done.

Your preference should be to use `refreshCells()` over `redrawRows()`. Only use `redrawRows()` if you find `refreshCells()` doesn't suit your needs.

## Refresh Cells

To get the grid to refresh the cells, call `api.refreshCells()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  | Performs change detection on all cells, refreshing cells where required. Module: [`RenderApiModule`](https://www.ag-grid.com/vue-data-grid/modules/). |

Each parameter is optional. The simplest is to call with no parameters which will refresh all cells using [change detection](https://www.ag-grid.com/vue-data-grid/change-detection/) (change detection means it will only refresh cells whose values have changed).

### Example Refresh Cells

Below shows calling `api.refreshCells()` with different scenarios using a mixture of the `rowNodes`, `columns` and `force` parameters. From the example, the following can be noted:

- The defaultColDef has `enableCellChangeFlash=true`, so cells that are refreshed will be flashed.
- Column A has `enableCellChangeFlash=false` which means this column is excluded from the flashing.
- The grid has two pinned rows at the top and two pinned rows at the bottom. This is to demonstrate that cell refreshing works for pinned rows also.
- The three buttons each make use of a **scramble** operation. The scramble operation selects 50% of the cells at random and assigns new values to them. This is done outside of the grid so the grid has not been informed of the data changes. Each button then gets the grid to refresh in a different way.
- The **Scramble & Refresh All** button will scramble the data, then call `api.refreshCells()`. You will notice that randomly half the cells will flash as the change detection only update the cells who's underlying values have changed.
- The **Scramble & Refresh Left to Right** button will scramble as before, then call `api.refreshCells({columns})` 5 times, 100ms apart, once for each column. This will show the grid refreshing one column at a time from left to right.
- The **Scramble & Refresh Top to Bottom** button will scramble as before, then call `api.refreshCells({rowNodes})` 20 times, 100ms apart, once for each row (including pinned rows). This will show the grid refreshing one row at a time from top to bottom.
- The checkbox **Force Refresh** impacts how the above three refreshes work. If checked, all the cells will get refreshed regardless of whether they have changes. In other words, change detection will not be used as part of the refresh.
- The checkbox **Suppress Flash** impacts how the above three refreshes work. If checked, flashing will not occur on any cell.

#### Refresh Cells

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  PinnedRowModule,
  RefreshCellsParams,
  RenderApiModule,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RenderApiModule,
  RowApiModule,
  HighlightChangesModule,
  PinnedRowModule,
  ClientSideRowModelModule,
]);

// placing in 13 rows, so there are exactly enough rows to fill the grid, makes
// the row animation look nice when you see all the rows
let data: any[] = [];

let topRowData: any[] = [];

let bottomRowData: any[] = [];

function createData(count: number): any[] {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}

function isForceRefreshSelected() {
  return (document.querySelector("#forceRefresh") as HTMLInputElement).checked;
}

function isSuppressFlashSelected() {
  return (document.querySelector("#suppressFlash") as HTMLInputElement).checked;
}

function callRefreshAfterMillis(
  params: RefreshCellsParams,
  millis: number,
  api: GridApi,
) {
  setTimeout(() => {
    api.refreshCells(params);
  }, millis);
}

function scramble() {
  data.forEach(scrambleItem);
  topRowData.forEach(scrambleItem);
  bottomRowData.forEach(scrambleItem);
}

function scrambleItem(item: any) {
  ["a", "b", "c", "d", "e", "f"].forEach((colId) => {
    // skip 50% of the cells so updates are random
    if (window.agRandom() > 0.5) {
      return;
    }
    item[colId] = Math.floor(window.agRandom() * 100);
  });
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <div>
          <button v-on:click="scrambleAndRefreshAll()">Scramble &amp; Refresh All</button>
          <button v-on:click="scrambleAndRefreshLeftToRight()">Scramble &amp; Refresh Left to Right</button>
          <button v-on:click="scrambleAndRefreshTopToBottom()">Scramble &amp; Refresh Top to Bottom</button>
        </div>
        <div>
          <label>
            <input type="checkbox" id="forceRefresh">
              Force Refresh
            </label>
            <label>
              <input type="checkbox" id="suppressFlash">
                Suppress Flash
              </label>
            </div>
          </div>
          <ag-grid-vue
            style="width: 100%; height: 100%;"
            @grid-ready="onGridReady"
            :columnDefs="columnDefs"
            :defaultColDef="defaultColDef"
            :rowData="rowData"
            :pinnedTopRowData="pinnedTopRowData"
            :pinnedBottomRowData="pinnedBottomRowData"></ag-grid-vue>
          </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "a", enableCellChangeFlash: false },
      { field: "b" },
      { field: "c" },
      { field: "d" },
      { field: "e" },
      { field: "f" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      enableCellChangeFlash: true,
    });
    const rowData = ref<any[] | null>([]);
    const pinnedTopRowData = ref<any[]>([]);
    const pinnedBottomRowData = ref<any[]>([]);

    function scrambleAndRefreshAll() {
      scramble();
      const params = {
        force: isForceRefreshSelected(),
        suppressFlash: isSuppressFlashSelected(),
      };
      gridApi.value!.refreshCells(params);
    }
    function scrambleAndRefreshLeftToRight() {
      scramble();
      ["a", "b", "c", "d", "e", "f"].forEach((col, index) => {
        const millis = index * 100;
        const params = {
          force: isForceRefreshSelected(),
          suppressFlash: isSuppressFlashSelected(),
          columns: [col],
        };
        callRefreshAfterMillis(params, millis, gridApi.value);
      });
    }
    function scrambleAndRefreshTopToBottom() {
      scramble();
      let frame = 0;
      let i;
      let rowNode;
      for (i = 0; i < gridApi.value.getPinnedTopRowCount(); i++) {
        rowNode = gridApi.value.getPinnedTopRow(i)!;
        refreshRow(rowNode, gridApi.value);
      }
      for (i = 0; i < gridApi.value.getDisplayedRowCount(); i++) {
        rowNode = gridApi.value.getDisplayedRowAtIndex(i)!;
        refreshRow(rowNode, gridApi.value);
      }
      for (i = 0; i < gridApi.value.getPinnedBottomRowCount(); i++) {
        rowNode = gridApi.value.getPinnedBottomRow(i)!;
        refreshRow(rowNode, gridApi.value);
      }
      function refreshRow(rowNode: IRowNode, api: GridApi) {
        const millis = frame++ * 100;
        const rowNodes = [rowNode]; // params needs an array
        const params: RefreshCellsParams = {
          force: isForceRefreshSelected(),
          suppressFlash: isSuppressFlashSelected(),
          rowNodes: rowNodes,
        };
        callRefreshAfterMillis(params, millis, api);
      }
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      // placing in 13 rows, so there are exactly enough rows to fill the grid, makes
      // the row animation look nice when you see all the rows
      data = createData(14);
      topRowData = createData(2);
      bottomRowData = createData(2);
      params.api.setGridOption("rowData", data);
      params.api.setGridOption("pinnedTopRowData", topRowData);
      params.api.setGridOption("pinnedBottomRowData", bottomRowData);
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      pinnedTopRowData,
      pinnedBottomRowData,
      onGridReady,
      scrambleAndRefreshAll,
      scrambleAndRefreshLeftToRight,
      scrambleAndRefreshTopToBottom,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Refresh Cells](https://www.ag-grid.com/examples/view-refresh/refresh-cells/vue3)

> **Note**
>
> You may be wondering why would you want to force refresh, what is the point in refreshing a cell that has no changes? The answer is to do with cells that don't show underlying data or depend on something other than just the underlying data. One example is a cell that might contain action buttons (add, delete, send etc) and you might want to disable the action buttons if the logged in user changes role (if roles are tied to the functions), or if it's past 5pm and you don't want to allow such operations past a certain time. In this case you may wish to update the cells even though the underlying data has not changed.

## Redraw Rows

Redraw rows is a much heavier operation than refreshing cells. If refreshing cells meets your needs, then don't use redraw rows. A row redraw will rip the row out of the DOM and draw it again from scratch.

Use redraw row if you want to create the row again from scratch. This is useful when you have changed property that only gets used when the row is created for the first time such as:

- Whether the row is [fullWidth](https://www.ag-grid.com/vue-data-grid/full-width-rows/) or not.
- The cellRenderer used for any cell (as this is specified once when the cell is created).
- You want to specify different styles for the row via the callbacks `getRowStyle()` or `getRowClass()`.

To get the grid to redraw rows, call `api.redrawRows()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `redrawRows` | `Function` |  |  | Remove row(s) from the DOM and recreate them again from scratch. Module: [`RowApiModule`](https://www.ag-grid.com/vue-data-grid/modules/). |

### Example Redraw Nodes

Below shows calling `api.redrawRows()` with different to change the background color of the rows. From the example, the following can be noted:

- The **Redraw All Rows** redraws all the rows using a different background color by calling `api.redrawRows()` with no parameters.
- The **Redraw Top Rows** redraws only the top half of the rows by calling `api.redrawRows({rowNodes})`.

#### Redraw Rows

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowStyle,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  RowClassParams,
  RowStyle,
  RowStyleModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowApiModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

let colorIndex = 0;

const colors = ["#99999944", "#cc333344", "#33cc3344", "#2244cc44"];

function createData(count: number) {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}

function progressColor() {
  colorIndex++;
  if (colorIndex === colors.length) {
    colorIndex = 0;
  }
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <button v-on:click="redrawAllRows()">Redraw All Rows</button>
        <button v-on:click="redrawTopRows()">Redraw Top Rows</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"
        :getRowStyle="getRowStyle"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { headerName: "A", field: "a" },
      { headerName: "B", field: "b" },
      { headerName: "C", field: "c" },
      { headerName: "D", field: "d" },
      { headerName: "E", field: "e" },
      { headerName: "F", field: "f" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const rowData = ref<any[] | null>(createData(12));
    const getRowStyle = ref<GetRowStyle>(
      (params: RowClassParams): RowStyle | undefined => {
        return {
          backgroundColor: colors[colorIndex],
        };
      },
    );

    function redrawAllRows() {
      progressColor();
      gridApi.value!.redrawRows();
    }
    function redrawTopRows() {
      progressColor();
      const rows = [];
      for (let i = 0; i < 6; i++) {
        const row = gridApi.value!.getDisplayedRowAtIndex(i)!;
        rows.push(row);
      }
      gridApi.value!.redrawRows({ rowNodes: rows });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      getRowStyle,
      onGridReady,
      redrawAllRows,
      redrawTopRows,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Redraw Rows](https://www.ag-grid.com/examples/view-refresh/redraw-rows/vue3)


---
product: "AG Grid"
title: "View Refresh"
description: "The grid has change detection. So as long as you are updating the data via the grid's API, the values displayed should be the most recent up to date values."
framework: react
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/react-data-grid/cell-content/"
    - title: "Find"
      url: "https://www.ag-grid.com/react-data-grid/find/"
    - title: "Notes"
      url: "https://www.ag-grid.com/react-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/react-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/react-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/react-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/react-data-grid/cell-expressions/"
    - title: "Reference Data"
      url: "https://www.ag-grid.com/react-data-grid/reference-data/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/react-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/llms.txt"
---

# View Refresh

The grid has change detection. So as long as you are updating the data via the grid's API, the values displayed should be the most recent up to date values.

However sometimes you may be updating the data outside of the grid's control. When you give data to the grid, the grid will not make a copy. Thus if you change the value of the data outside of the grid, the grid will not be impacted by that data change.

To deal with the scenario where the row data is changed without the grid being aware, the grid provides the following methods:

- **Refresh Cells**: `api.refreshCells(cellRefreshParams)` - Gets the grid to refresh all cells. Change detection will be used to refresh only cells whose display cell values are out of sync with the actual value. If using a [cellRenderer](https://www.ag-grid.com/react-data-grid/component-cell-renderer/) with a refresh method, the refresh method will get called.
- **Redraw Rows**: `api.redrawRows(redrawRowsParams)` - Removes the rows from the DOM and draws them again from scratch. The cells are created again from scratch. No change detection is done. No refreshing of cells is done.

Your preference should be to use `refreshCells()` over `redrawRows()`. Only use `redrawRows()` if you find `refreshCells()` doesn't suit your needs.

## Refresh Cells

To get the grid to refresh the cells, call `api.refreshCells()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  |  |

Each parameter is optional. The simplest is to call with no parameters which will refresh all cells using [change detection](https://www.ag-grid.com/react-data-grid/change-detection/) (change detection means it will only refresh cells whose values have changed).

### Example Refresh Cells

Below shows calling `api.refreshCells()` with different scenarios using a mixture of the `rowNodes`, `columns` and `force` parameters. From the example, the following can be noted:

- The defaultColDef has `enableCellChangeFlash=true`, so cells that are refreshed will be flashed.
- Column A has `enableCellChangeFlash=false` which means this column is excluded from the flashing.
- The grid has two pinned rows at the top and two pinned rows at the bottom. This is to demonstrate that cell refreshing works for pinned rows also.
- The three buttons each make use of a **scramble** operation. The scramble operation selects 50% of the cells at random and assigns new values to them. This is done outside of the grid so the grid has not been informed of the data changes. Each button then gets the grid to refresh in a different way.
- The **Scramble & Refresh All** button will scramble the data, then call `api.refreshCells()`. You will notice that randomly half the cells will flash as the change detection only update the cells who's underlying values have changed.
- The **Scramble & Refresh Left to Right** button will scramble as before, then call `api.refreshCells({columns})` 5 times, 100ms apart, once for each column. This will show the grid refreshing one column at a time from left to right.
- The **Scramble & Refresh Top to Bottom** button will scramble as before, then call `api.refreshCells({rowNodes})` 20 times, 100ms apart, once for each row (including pinned rows). This will show the grid refreshing one row at a time from top to bottom.
- The checkbox **Force Refresh** impacts how the above three refreshes work. If checked, all the cells will get refreshed regardless of whether they have changes. In other words, change detection will not be used as part of the refresh.
- The checkbox **Suppress Flash** impacts how the above three refreshes work. If checked, flashing will not occur on any cell.

#### Refresh Cells

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  PinnedRowModule,
  RefreshCellsParams,
  RenderApiModule,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RenderApiModule,
  RowApiModule,
  HighlightChangesModule,
  PinnedRowModule,
  ClientSideRowModelModule,
];

// placing in 13 rows, so there are exactly enough rows to fill the grid, makes
// the row animation look nice when you see all the rows
let data: any[] = [];

let topRowData: any[] = [];

let bottomRowData: any[] = [];

const createData: (count: number) => any[] = (count: number) => {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
};

function isForceRefreshSelected() {
  return (document.querySelector("#forceRefresh") as HTMLInputElement).checked;
}

function isSuppressFlashSelected() {
  return (document.querySelector("#suppressFlash") as HTMLInputElement).checked;
}

function callRefreshAfterMillis(
  params: RefreshCellsParams,
  millis: number,
  api: GridApi,
) {
  setTimeout(() => {
    api.refreshCells(params);
  }, millis);
}

function scramble() {
  data.forEach(scrambleItem);
  topRowData.forEach(scrambleItem);
  bottomRowData.forEach(scrambleItem);
}

function scrambleItem(item: any) {
  ["a", "b", "c", "d", "e", "f"].forEach((colId) => {
    // skip 50% of the cells so updates are random
    if (window.agRandom() > 0.5) {
      return;
    }
    item[colId] = Math.floor(window.agRandom() * 100);
  });
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>([]);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "a", enableCellChangeFlash: false },
    { field: "b" },
    { field: "c" },
    { field: "d" },
    { field: "e" },
    { field: "f" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      enableCellChangeFlash: true,
    };
  }, []);
  const pinnedTopRowData = useMemo<any[]>(() => {
    return [];
  }, []);
  const pinnedBottomRowData = useMemo<any[]>(() => {
    return [];
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    // placing in 13 rows, so there are exactly enough rows to fill the grid, makes
    // the row animation look nice when you see all the rows
    data = createData(14);
    topRowData = createData(2);
    bottomRowData = createData(2);
    setRowData(data);
    params.api.setGridOption("pinnedTopRowData", topRowData);
    params.api.setGridOption("pinnedBottomRowData", bottomRowData);
  }, []);

  const scrambleAndRefreshAll = useCallback(() => {
    scramble();
    const params = {
      force: isForceRefreshSelected(),
      suppressFlash: isSuppressFlashSelected(),
    };
    gridRef.current!.api.refreshCells(params);
  }, []);

  const scrambleAndRefreshLeftToRight = useCallback(() => {
    scramble();
    ["a", "b", "c", "d", "e", "f"].forEach((col, index) => {
      const millis = index * 100;
      const params = {
        force: isForceRefreshSelected(),
        suppressFlash: isSuppressFlashSelected(),
        columns: [col],
      };
      callRefreshAfterMillis(params, millis, gridRef.current!.api);
    });
  }, []);

  const scrambleAndRefreshTopToBottom = useCallback(() => {
    scramble();
    let frame = 0;
    let i;
    let rowNode;
    for (i = 0; i < gridRef.current!.api.getPinnedTopRowCount(); i++) {
      rowNode = gridRef.current!.api.getPinnedTopRow(i)!;
      refreshRow(rowNode, gridRef.current!.api);
    }
    for (i = 0; i < gridRef.current!.api.getDisplayedRowCount(); i++) {
      rowNode = gridRef.current!.api.getDisplayedRowAtIndex(i)!;
      refreshRow(rowNode, gridRef.current!.api);
    }
    for (i = 0; i < gridRef.current!.api.getPinnedBottomRowCount(); i++) {
      rowNode = gridRef.current!.api.getPinnedBottomRow(i)!;
      refreshRow(rowNode, gridRef.current!.api);
    }
    function refreshRow(rowNode: IRowNode, api: GridApi) {
      const millis = frame++ * 100;
      const rowNodes = [rowNode]; // params needs an array
      const params: RefreshCellsParams = {
        force: isForceRefreshSelected(),
        suppressFlash: isSuppressFlashSelected(),
        rowNodes: rowNodes,
      };
      callRefreshAfterMillis(params, millis, api);
    }
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div>
              <button onClick={scrambleAndRefreshAll}>
                Scramble &amp; Refresh All
              </button>
              <button onClick={scrambleAndRefreshLeftToRight}>
                Scramble &amp; Refresh Left to Right
              </button>
              <button onClick={scrambleAndRefreshTopToBottom}>
                Scramble &amp; Refresh Top to Bottom
              </button>
            </div>
            <div>
              <label>
                <input type="checkbox" id="forceRefresh" />
                Force Refresh
              </label>
              <label>
                <input type="checkbox" id="suppressFlash" />
                Suppress Flash
              </label>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              pinnedTopRowData={pinnedTopRowData}
              pinnedBottomRowData={pinnedBottomRowData}
              onGridReady={onGridReady}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Refresh Cells](https://www.ag-grid.com/examples/view-refresh/refresh-cells/reactFunctionalTs/)

> **Note**
>
> You may be wondering why would you want to force refresh, what is the point in refreshing a cell that has no changes? The answer is to do with cells that don't show underlying data or depend on something other than just the underlying data. One example is a cell that might contain action buttons (add, delete, send etc) and you might want to disable the action buttons if the logged in user changes role (if roles are tied to the functions), or if it's past 5pm and you don't want to allow such operations past a certain time. In this case you may wish to update the cells even though the underlying data has not changed.

## Redraw Rows

Redraw rows is a much heavier operation than refreshing cells. If refreshing cells meets your needs, then don't use redraw rows. A row redraw will rip the row out of the DOM and draw it again from scratch.

Use redraw row if you want to create the row again from scratch. This is useful when you have changed property that only gets used when the row is created for the first time such as:

- Whether the row is [fullWidth](https://www.ag-grid.com/react-data-grid/full-width-rows/) or not.
- The cellRenderer used for any cell (as this is specified once when the cell is created).
- You want to specify different styles for the row via the callbacks `getRowStyle()` or `getRowClass()`.

To get the grid to redraw rows, call `api.redrawRows()`. The interface is as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `redrawRows` | `Function` |  |  |  |

### Example Redraw Nodes

Below shows calling `api.redrawRows()` with different to change the background color of the rows. From the example, the following can be noted:

- The **Redraw All Rows** redraws all the rows using a different background color by calling `api.redrawRows()` with no parameters.
- The **Redraw Top Rows** redraws only the top half of the rows by calling `api.redrawRows({rowNodes})`.

#### Redraw Rows

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowStyle,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowApiModule,
  RowClassParams,
  RowStyle,
  RowStyleModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [RowApiModule, RowStyleModule, ClientSideRowModelModule];

let colorIndex = 0;

const colors = ["#99999944", "#cc333344", "#33cc3344", "#2244cc44"];

function createData(count: number) {
  const result = [];
  for (let i = 1; i <= count; i++) {
    result.push({
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return result;
}

function progressColor() {
  colorIndex++;
  if (colorIndex === colors.length) {
    colorIndex = 0;
  }
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(createData(12));
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { headerName: "A", field: "a" },
    { headerName: "B", field: "b" },
    { headerName: "C", field: "c" },
    { headerName: "D", field: "d" },
    { headerName: "E", field: "e" },
    { headerName: "F", field: "f" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
    };
  }, []);
  const getRowStyle = useCallback(
    (params: RowClassParams): RowStyle | undefined => {
      return {
        backgroundColor: colors[colorIndex],
      };
    },
    [],
  );

  const redrawAllRows = useCallback(() => {
    progressColor();
    gridRef.current!.api.redrawRows();
  }, []);

  const redrawTopRows = useCallback(() => {
    progressColor();
    const rows = [];
    for (let i = 0; i < 6; i++) {
      const row = gridRef.current!.api.getDisplayedRowAtIndex(i)!;
      rows.push(row);
    }
    gridRef.current!.api.redrawRows({ rowNodes: rows });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <button onClick={redrawAllRows}>Redraw All Rows</button>
            <button onClick={redrawTopRows}>Redraw Top Rows</button>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              getRowStyle={getRowStyle}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Redraw Rows](https://www.ag-grid.com/examples/view-refresh/redraw-rows/reactFunctionalTs/)
